{inputs, self, ...}:
let
  inherit (inputs.nixpkgs) lib;
  isDirectory = _name: type: type == "directory";
  hostNames = builtins.attrNames (
    lib.filterAttrs isDirectory (builtins.readDir ./.)
  );
  hosts = lib.genAttrs hostNames (name: {
    imports = [
      (./. + "/${name}")
    ];
  });
in 
{

  nixosConfigurations = lib.map (host: lib.nixosSystem {
    system = "x86_64-linux";
    modules = host;
    specialArgs = { inherit inputs; };
  }) (builtins.attrValues hosts);
}
